.. SPDX-License-Identifier: GPL-2.0+

U-Boot for Amlogic W400 (S922X)
===============================

W400 is a reference board manufactured by Amlogic with the following specification:

 - Amlogic S922X ARM Cortex-A53 dual-core + Cortex-A73 quad-core SoC
 - 2GB DDR4 SDRAM
 - 10/100 Ethernet (Internal PHY)
 - 1x USB 3.0 Host
 - eMMC
 - SDcard
 - Infrared receiver
 - SDIO WiFi Module
 - MIPI DSI Connector
 - Audio HAT Connector
 - PCI-E M.2 Connector

Schematics are available from Amlogic on demand.

U-Boot Compilation
------------------

.. code-block:: bash

    $ export CROSS_COMPILE=aarch64-none-elf-
    $ make w400_defconfig
    $ make

U-Boot Signing with Pre-Built FIP repo
--------------------------------------

.. code-block:: bash

    $ git clone https://github.com/LibreELEC/amlogic-boot-fip --depth=1
    $ cd amlogic-boot-fip
    $ mkdir my-output-dir
    $ ./build-fip.sh jethub-j100 /path/to/u-boot/u-boot.bin my-output-dir

U-Boot Manual Signing
---------------------

Amlogic does not provide sources for the firmware and tools needed to create a bootloader
image so it is necessary to obtain binaries from sources published by the board vendor:

.. code-block:: bash

    $ wget https://releases.linaro.org/archive/13.11/components/toolchain/binaries/gcc-linaro-aarch64-none-elf-4.8-2013.11_linux.tar.xz
    $ wget https://releases.linaro.org/archive/13.11/components/toolchain/binaries/gcc-linaro-arm-none-eabi-4.8-2013.11_linux.tar.xz
    $ tar xvfJ gcc-linaro-aarch64-none-elf-4.8-2013.11_linux.tar.xz
    $ tar xvfJ gcc-linaro-arm-none-eabi-4.8-2013.11_linux.tar.xz
    $ export PATH=$PWD/gcc-linaro-aarch64-none-elf-4.8-2013.11_linux/bin:$PWD/gcc-linaro-arm-none-eabi-4.8-2013.11_linux/bin:$PATH
    $ git clone https://github.com/BayLibre/u-boot.git -b buildroot-openlinux-20180418 amlogic-u-boot
    $ cd amlogic-u-boot
    $ make g12b_w400_v1_defconfig
    $ make
    $ export UBOOTDIR=$PWD

Download the latest Amlogic buildroot package and extract it:

.. code-block:: bash

    $ wget http://openlinux2.amlogic.com:8000/ARM/filesystem/Linux_BSP/buildroot_openlinux_kernel_4.9_fbdev_20180706.tar.gz
    $ tar xfz buildroot_openlinux_kernel_4.9_fbdev_20180706.tar.gz buildroot_openlinux_kernel_4.9_fbdev_20180706/bootloader
    $ export BRDIR=$PWD/buildroot_openlinux_kernel_4.9_fbdev_20180706
    $ export FIPDIR=$BRDIR/bootloader/uboot-repo/fip

Go back to the mainline U-Boot source tree then:

.. code-block:: bash

    $ mkdir fip

    $ wget https://github.com/BayLibre/u-boot/releases/download/v2017.11-libretech-cc/blx_fix_g12a.sh -O fip/blx_fix.sh
    $ cp $UBOOTDIR/build/scp_task/bl301.bin fip/
    $ cp $UBOOTDIR/build/board/amlogic/g12b_w400_v1/firmware/acs.bin fip/
    $ cp $BRDIR/bootloader/uboot-repo/bl2/bin/g12b/bl2.bin fip/
    $ cp $BRDIR/bootloader/uboot-repo/bl30/bin/g12b/bl30.bin fip/
    $ cp $BRDIR/bootloader/uboot-repo/bl31_1.3/bin/g12b/bl31.img fip/
    $ cp $FIPDIR/g12b/ddr3_1d.fw fip/
    $ cp $FIPDIR/g12b/ddr4_1d.fw fip/
    $ cp $FIPDIR/g12b/ddr4_2d.fw fip/
    $ cp $FIPDIR/g12b/diag_lpddr4.fw fip/
    $ cp $FIPDIR/g12b/lpddr4_1d.fw fip/
    $ cp $FIPDIR/g12b/lpddr4_2d.fw fip/
    $ cp $FIPDIR/g12b/piei.fw fip/
    $ cp $FIPDIR/g12b/aml_ddr.fw fip/
    $ cp u-boot.bin fip/bl33.bin

    $ sh fip/blx_fix.sh \
         fip/bl30.bin \
         fip/zero_tmp \
         fip/bl30_zero.bin \
         fip/bl301.bin \
         fip/bl301_zero.bin \
         fip/bl30_new.bin \
         bl30

    $ sh fip/blx_fix.sh \
         fip/bl2.bin \
         fip/zero_tmp \
         fip/bl2_zero.bin \
         fip/acs.bin \
         fip/bl21_zero.bin \
         fip/bl2_new.bin \
         bl2

    $ $FIPDIR/g12b/aml_encrypt_g12b --bl30sig --input fip/bl30_new.bin \
                                              --output fip/bl30_new.bin.g12a.enc \
                                              --level v3
    $ $FIPDIR/g12b/aml_encrypt_g12b --bl3sig --input fip/bl30_new.bin.g12a.enc \
                                             --output fip/bl30_new.bin.enc \
                                             --level v3 --type bl30
    $ $FIPDIR/g12b/aml_encrypt_g12b --bl3sig --input fip/bl31.img \
                                             --output fip/bl31.img.enc \
                                             --level v3 --type bl31
    $ $FIPDIR/g12b/aml_encrypt_g12b --bl3sig --input fip/bl33.bin --compress lz4 \
                                             --output fip/bl33.bin.enc \
                                             --level v3 --type bl33
    $ $FIPDIR/g12b/aml_encrypt_g12b --bl2sig --input fip/bl2_new.bin \
                                             --output fip/bl2.n.bin.sig
    $ $FIPDIR/g12b/aml_encrypt_g12b --bootmk \
                                    --output fip/u-boot.bin \
                                    --bl2 fip/bl2.n.bin.sig \
                                    --bl30 fip/bl30_new.bin.enc \
                                    --bl31 fip/bl31.img.enc \
                                    --bl33 fip/bl33.bin.enc \
                                    --ddrfw1 fip/ddr4_1d.fw \
                                    --ddrfw2 fip/ddr4_2d.fw \
                                    --ddrfw3 fip/ddr3_1d.fw \
                                    --ddrfw4 fip/piei.fw \
                                    --ddrfw5 fip/lpddr4_1d.fw \
                                    --ddrfw6 fip/lpddr4_2d.fw \
                                    --ddrfw7 fip/diag_lpddr4.fw \
                                    --ddrfw8 fip/aml_ddr.fw \
                                    --level v3

Then write U-Boot to SD or eMMC with:

.. code-block:: bash

    $ DEV=/dev/boot_device
    $ dd if=fip/u-boot.bin.sd.bin of=$DEV conv=fsync,notrunc bs=512 skip=1 seek=1
    $ dd if=fip/u-boot.bin.sd.bin of=$DEV conv=fsync,notrunc bs=1 count=440
